天天看点

HDU 5119 Happy Matt Friends(dp) Happy Matt Friends

Happy Matt Friends

Time Limit: 6000/6000 MS (Java/Others)    Memory Limit: 510000/510000 K (Java/Others)

Total Submission(s): 3047    Accepted Submission(s): 1203

Problem Description Matt has N friends. They are playing a game together.

Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins.

Matt wants to know the number of ways to win.  

Input The first line contains only one integer T , which indicates the number of test cases.

For each test case, the first line contains two integers N, M (1 ≤ N ≤ 40, 0 ≤ M ≤ 10 6).

In the second line, there are N integers ki (0 ≤ k i ≤ 10 6), indicating the i-th friend’s magic number.  

Output For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1) and y indicates the number of ways where Matt can win.  

Sample Input

2
3 2
1 2 3
3 3
1 2 3
        

Sample Output

Case #1: 4
Case #2: 2


   
    
     Hint
    In the first sample, Matt can win by selecting:
friend with number 1 and friend with number 2. The xor sum is 3.
friend with number 1 and friend with number 3. The xor sum is 2.
friend with number 2. The xor sum is 2.
friend with number 3. The xor sum is 3. Hence, the answer is 4.
   
        

题意:从N个数中找出满足异或和不小于M的方案总数。

dp[i][j]:第i个位置异或值为j的方案数;

第i-1个位置的异或值为j的方案数为第i个位置异或值为j的方案数一部分,同时也是第i个位置异或值为j^k[i]方案数的一部分;

然后令i:1~n j:0~INF 算出每个位置每个异或值的情况数;

开始时要初始化dp[1][k[1]] dp[1][0],因为后面会用到;

最后令i:m~INF 将所有满足条件的dp[n][i]累加;

TIPs:long long~

#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
using namespace std;
typedef long long ll;
const int N=50;
const int INF=(1<<20)+10;
int k[N];
ll dp[N][INF];
int main(){
	int t,cas=1;
	scanf("%d",&t);
	while(t--){
		int n,m;
		ll ans=0;
		scanf("%d %d",&n,&m);
		for(int i=1;i<=n;i++){
			scanf("%d",&k[i]);
		}
		memset(dp,0,sizeof(dp));
		dp[1][0]=dp[1][k[1]]=1;
		for(int i=1;i<=n;i++){
			for(int j=0;j<INF;j++){
				dp[i][j]+=dp[i-1][j];
				dp[i][j^k[i]]+=dp[i-1][j];
			}
		}
		for(int i=m;i<=INF;i++){
			ans+=dp[n][i];
		}

		printf("Case #%d: %lld\n",cas++,ans);
	}
}
           

面向题解做题系列= =一开始就搜了一下发现是DP然后才知道大概要怎么做唉……独立思考我应该是想不到要酱紫做的~